function [Gamma,k_vec] = func_assemble_Gamma_matrix(L,n)

[Gamma_X,Gamma_Lm1] = func_definite_connection_coefs(L,n);

Gamma = zeros(length(Gamma_Lm1),(L-1));
k_vec = (-(L-2):(L-2))';

% Back fill the matrix for (x-k) >= (L-1)
for II = 1:(L-1)
    Gamma(1:(L-1),II) = Gamma_Lm1(1:(L-1));
end

for II = 1:(L-2)
    k_vals = ((-(L-2)+II):(II-1))';
    row_start = find(k_vec == k_vals(1));
    row_stop = find(k_vec == k_vals(end));
    Gamma(row_start:row_stop,II) = Gamma_X((II-1)*(L-2) + (1:(L-2)));
end
Gamma(:,end) = Gamma_Lm1;
