function [Q_tilde]=func_calc_Qtilde_matrix(L,n,p)

% This function calculates the Q_tilde matrix, as per equation (21) in
% Zhang et. al
%first calculate Q_i,j (there should be (L-2)*(L-2) Q matrices defined by
% the nested loop below)
for II = 1:L-2
    for JJ = 1:L-2
        for KK = 1:L-2
            for MM = 1:L-2
                
                index1 = 2*II-JJ;
                if (index1<0)|(index1>(L-1))
                    p1 = 0;
                else
                    p1 = p(index1 + 1);
                end
                
                index2 = (L-1-2*KK+MM);
                if (index2<0)|(index2>(L-1))
                    p2 = 0;
                else
                    p2 = p(index2 + 1);
                end
                
                %save as Q_II,JJ
                eval(['Q' num2str(II) 'c' num2str(JJ) '(KK,MM) = p1*p2;']);
                clear p1 p2 index1 index2
            end
        end
    end
end

% Combine the Q_i,j matrices into the global Q matrix
% i.e. [Q11 Q12 Q13 Q14;Q21 Q22 Q23 Q24;Q31 Q32 Q33 Q34;Q41 Q42 Q43 Q44];
clear Q
for II = 1:L-2
    clear temp
    for JJ = 1:L-2
        
        if JJ == 1
            eval(['temp = Q' num2str(II) 'c' num2str(JJ) ';']);
        else
            eval(['temp = cat(2,temp,Q' num2str(II) 'c' num2str(JJ) ');']);
        end
        eval(['clear Q' num2str(II) 'c' num2str(JJ) ';']);
    end
    
    if II == 1
        Q = temp;
    else
        Q = cat(1,Q,temp);
    end
end

% define Q_tilde as equation (21)
Q_tilde = (2^(1-n)*eye(size(Q)) - Q);

