function [d] = func_calc_d_vector(L,n,p,Gamma_Lm1)

% This function calculate the d^i values, as per equation (18) and (19) in
% Zhang et. al
% there should be (L-2) d values (i.e. d1, d2, d3, d4)

for II = 1:(L-2)
    for KK = 1:(L-2);
        temp = 0;
        for I1 = 0:(L-1);
            for J1 = 0:(L-1);
                % set the gam parameter to zero, it will be updated below if
                % I1 and J1 are suitable according to equation (17)
                p1 = p(I1 + 1);
                p2 = p(J1 + 1);
                gam = 0;
                
                if ((2*II - J1)>=(L-1))|((2*KK + I1)<=(L-1))
                    gam_index = 2*(II - (L-2) + (KK-1)) + I1 - J1;
                    
                    % grab the Gamma(L-1) value as necessary. If
                    % |gam_index| > L-2 then set gam = 0 as per (8)
                    if abs(gam_index) <= (L-2)
                        gam_in_matlab_index = gam_index + (L-1);
                        gam = Gamma_Lm1(gam_in_matlab_index);
                    else
                        gam = 0;
                    end
                    clear gam_index gam_in_matlab_index
                end
                
                % add up the summation in (18)
                d_temp = p1*p2*gam;
                temp = temp + d_temp;
                
                clear d_temp p1 p2 gam
            end
        end
        eval(['d' num2str(II) '(KK,1) = temp;']);
        clear temp
    end
end
clear I1 II J1 KK

% create the d vector
clear d
for II = 1:(L-2)
    if II == 1
        d = d1;
        eval(['clear d' num2str(II) ';']);
    else
        eval(['d = cat(1,d,d' num2str(II) ');']);
        eval(['clear d' num2str(II) ';']);
    end
end
