function [phi_vec,pIndex]=func_calc_phi(L,n)

p = func_calc_filter_coefs(L);

% compile the P matrix
for JJ = 1:(L-2)
    for KK = 1:(L-2)
        
        p_index = 2*JJ-KK;
        if (p_index>=0) & (p_index<=(L-1))
            P(JJ,KK) = p(p_index + 1);
        else
            P(JJ,KK) = 0;
        end
        clear p_index
    end
end
clear JJ KK

eig_of_interest = 2^(-n);

[v,d] = eig(P);
d_vec = diag(d);

count = 0;
for II = 1:length(d_vec);
    if (d_vec(II) > 0.9999*eig_of_interest)&(d_vec(II) < 1.0001*eig_of_interest)
        count = count + 1;
        eig_index(count,1) =II;
    end
end

if length(eig_index) > 1
    keyboard   %You've got a problem!
end

phi_vec = v(:,eig_index);

temp = 0;
for II = 1:(L-2)
    temp = temp + (-II)^n*phi_vec(II);
end
scale_factor = factorial(n)/temp;

phi_vec = scale_factor*phi_vec;
pIndex = cumsum(ones((L-2),1));