function [Gamma_mat] = func_construct_GammaMat_0to1(L,J,n,Gamma,GammaIndex);

kIndex = ((2-L):(2^J-1))';
lIndex = ((2-L):(2^J-1))';

%----------------------------------------------------------------------
% Back fill the Gamma terms according to equation (10) of Zhang et al.
xVec = (1:(L-2))';
for II = 1:length(GammaIndex);
    for XX = 1:length(xVec);
        gVal = -(GammaIndex(II));
        xVal = xVec(XX);
        if (xVal + gVal) >= (L-1)
            gIndex = find(GammaIndex == gVal);
            Gamma(II,XX) = ((-1)^n)*Gamma(gIndex,(L-1));
        end
        clear gVal xVal gIndex
    end
end
clear II XX xVec

%----------------------------------------------------------------------
% Determine the coefficients for the Gamma matrices
% Note this is only for x = 0 -> 1
for LL = 1:length(lIndex)
    for KK = 1:length(kIndex)
        kVal = kIndex(KK);
        lVal = lIndex(LL);
        G1 = 0;
        G2 = 0;
        
        %-----------------------------------
        index = find(GammaIndex == (kVal-lVal));
        xVal = (2^J-lVal);
        if min(size(index)) ~= 0
            if xVal > 0
                if xVal >= (L-1)
                    xVal = (L-1);
                end
                    
                G1 = Gamma(index,xVal);
            end
        end
        clear index xVal
        %-----------------------------------
        index = find(GammaIndex == (kVal-lVal));
        xVal = (-lVal);
        if min(size(index)) ~= 0
            if xVal > 0
                if xVal >= (L-1)
                    xVal = (L-1);
                end
                G2 = Gamma(index,xVal);
            end
        end
        clear index xVal
        
        Gamma_mat(LL,KK) = 2^(n*J)*(G1 - G2);
        clear G1 G2
    end
end

